#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct DatasetOriginMetadata {
    #[builder(default, into)]
    #[serde(rename = "path", skip_serializing_if = "Option::is_none", default)]
    path: Option<String>,
    #[builder(default, into)]
    #[serde(
        rename = "xSeriesIsAbsolute",
        skip_serializing_if = "Option::is_none",
        default
    )]
    x_series_is_absolute: Option<bool>,
    #[builder(default, into)]
    #[serde(
        rename = "schemaDirectivePath",
        skip_serializing_if = "Option::is_none",
        default
    )]
    schema_directive_path: Option<String>,
    #[builder(default, into)]
    #[serde(
        rename = "xSeriesColumnName",
        skip_serializing_if = "Option::is_none",
        default
    )]
    x_series_column_name: Option<String>,
    #[builder(default, into)]
    #[serde(
        rename = "xSeriesTimeUnit",
        skip_serializing_if = "Option::is_none",
        default
    )]
    x_series_time_unit: Option<super::super::super::api::TimeUnit>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::TimestampMetadata>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "timestampMetadata",
        skip_serializing_if = "Option::is_none",
        default
    )]
    timestamp_metadata: Option<Box<super::TimestampMetadata>>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::ChannelConfig>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(rename = "channelConfig", skip_serializing_if = "Option::is_none", default)]
    channel_config: Option<Box<super::ChannelConfig>>,
}
impl DatasetOriginMetadata {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new() -> Self {
        Self::builder().build()
    }
    /// Deprecated in favor of FileOriginMetadata
    #[inline]
    pub fn path(&self) -> Option<&str> {
        self.path.as_ref().map(|o| &**o)
    }
    /// Deprecated in favor of FileOriginMetadata
    #[inline]
    pub fn x_series_is_absolute(&self) -> Option<bool> {
        self.x_series_is_absolute.as_ref().map(|o| *o)
    }
    /// Deprecated in favor of FileOriginMetadata
    #[inline]
    pub fn schema_directive_path(&self) -> Option<&str> {
        self.schema_directive_path.as_ref().map(|o| &**o)
    }
    /// Deprecated in favor of FileOriginMetadata
    #[inline]
    pub fn x_series_column_name(&self) -> Option<&str> {
        self.x_series_column_name.as_ref().map(|o| &**o)
    }
    /// Deprecated in favor of FileOriginMetadata
    #[inline]
    pub fn x_series_time_unit(&self) -> Option<&super::super::super::api::TimeUnit> {
        self.x_series_time_unit.as_ref().map(|o| &*o)
    }
    /// Deprecated in favor of FileOriginMetadata
    #[inline]
    pub fn timestamp_metadata(&self) -> Option<&super::TimestampMetadata> {
        self.timestamp_metadata.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn channel_config(&self) -> Option<&super::ChannelConfig> {
        self.channel_config.as_ref().map(|o| &**o)
    }
}
